class Ball {
  //반지름
  float r;
  // x, y 좌표 
  float x,y;
  // x,y 힘의 크기
  float maxX, maxY;
  // 공의 속도 
  float xspeed,yspeed;
  // 힘의 크기가 줄어드는 속도
  float maxXspeed, maxYspeed;
  color c = color(100,50,100);
  color saveColor,highlightColor = color(255,255,255);
  //생성자
  Ball(float tempR){
    r = tempR;
    x =random(100,400);
    y = random(100,400);
    maxX = 0;
    maxY = 0;
    maxXspeed = 0.1;
    maxYspeed = 0.1;
  }
  // 색 설정 
  void setColor(color nowColor){
    c  = nowColor;
    saveColor = nowColor;
  }
  // 움직임을 다룸 
  void move() {
    // 힘의 크기가 0이 아니면 
    if(maxX != 0){
      // 공의 이동 
      x += xspeed; 
      // 힘의 크기가 줄어듬
      maxX -= maxXspeed; 
      if( maxX < 0 ) maxX =0; 
    }
    // 힘의 크기가 0이 아니면
    if( maxY != 0){
      // 공의 이동
      y += yspeed;
      // 힘의 크기가 줄어듬
      maxY -= maxYspeed;
      if( maxY < 0 ) maxY =0;
    }
    //벽과 만났을때 방향 전환 
  if (x+r > width || x-r < 0) {
     xspeed *= - 1;
     // 화면에서 이동이 불가능한 경우 
     if( x+r-30 > width  || x-r < -30){
       reLocation(); 
     }
  }
  // 벽과 만났을때 방향 전환
  if (y+r > height || y-r < 0) {
    yspeed *= - 1;
    // 화면에서 이동이 불가능한 경우
    if( y+r-30 > height  || y-r < -30){
      reLocation();  
    }
  }
 }
 //움직임 설정
 void setMove(float nowX, float nowY){
    maxX += nowX;
    maxY += nowY;
    xspeed = maxX / 10;
    yspeed = maxY / 10;
    if( maxX > 30) maxX = 30;
    if( maxY > 30) maxY = 30;
  }
  // 반짝임 효과와 방향 전환 
  void highlight(){
    c = highlightColor;
    xspeed *= -1;
    yspeed *= -1;
  }
  // 볼을 그림
  void display() {
    stroke(0);
    fill(c);
    ellipse(x,y,r*2,r*2);
    c = saveColor;
  }
  // 공의 위치 지정 
  void setLocation(float tempX, float tempY) {
    x = tempX;
    y = tempY;
  }
  //공의 위치 새롭게 할당
  void reLocation()
  {
     x = random(100,200);
     y = random(100,200);
  }
  // 교차 확인 함수
  boolean intersect(Ball b) {
    float distance = dist(x,y,b.x,b.y);
    if (distance < r + b.r) {
       return true;
    } 
    else {
       return false;
    }
  }
}
