// A Cell object
class Cell {
// x,y 좌표
float x,y;
// 가로, 세로 크기
float w,h;
//현재 상태 0일경우 비어있음, 1일경우 O, 2일경우 X
int state;
// Cell Constructor
Cell(float tempX, float tempY, float tempW, float tempH) {
  x = tempX;
  y = tempY;
  w = tempW;
  h = tempH;
  state = 0;
}
boolean click(float nowX, float nowY,int nowState) {
  //마우스 클릭한 영역이 현재 객체 일경우 
  if( x < nowX && x+w > nowX && y < nowY && y+h > nowY)
  {
    //클릭한 객체의 상태가 비어있을경우
    if( state == 0){
        //클릭한 객체의 상태를 홀수짝수로 구별
        state = (nowState % 2) +1;
        return true;      
    }
    else{
       return false; 
    }
  }
  else{
     return true; 
  }
}
void display(){
  fill(255);
  rect(x,y,w,h);
  //상태가 1일 경우 O 그리기
  if( state == 1)
  {
    fill(0);
    ellipse(x+50,y+50, w-50,h-50);
    fill(255);
    ellipse(x+50,y+50, w-60,h-60);
  }
  // 상태가 2일경우 X 그리기
  else if( state == 2)
  {
    // line() 이용
    //line(x+20,y+20,x+80,y+80);
    //line(x+20,y+80, x+80,y+20);
    
    // vertex 이용
     fill(0);
     beginShape();
     vertex(x+20,y+20);
     vertex(x+25,y+20);
     vertex(x+50,y+45);
     vertex(x+75,y+20);
     vertex(x+80,y+20);
     vertex(x+55,y+50);
     vertex(x+80,y+80);
     vertex(x+75,y+80);
     vertex(x+50,y+55);
     vertex(x+25,y+80);
     vertex(x+20,y+80);
     vertex(x+45,y+50);
     endShape();
  }
}

int getState(){
  return state;
}

}


