// Cell 객체 생성
Cell[][] board;
// 세로
int cols = 3;
// 가로 
int rows = 3;
//현재 마우스 클릭 count
int count = 0;
//최대 마우스 클릭 count
int maxCount = cols * rows +1;
void setup() {
  //크기는 가로 세로 * 100
  size(cols*100,rows*100);
  //가로 세로 크기만큼 객체 생성
  board = new Cell[cols][rows]; 
  // 초기화 함수 호출 
  startUp();
}
// board 초기화 함수
void startUp(){
   for(int i = 0 ; i < cols; i++){
     for(int j = 0; j < rows; j++) {
         board[i][j] = new Cell((i*100)+1,(j*100)+1,100,100);
     }
  }
}
void draw() {
  background(0);
  fill(255);
  for (int i = 0; i < cols; i++ ) {
    for (int j = 0; j < rows; j++ ) {
        board[i][j].display();
    }
  }
  // 승패 유무 확인 함수 호출
  checked();
}

void mousePressed() {
  //클릭 했을 경우 클릭카운트 상승
  count++;
  for (int i = 0; i < cols; i++ ){
    for (int j = 0; j < rows; j++ ){
         //클릭한 지역에 이미 그림(O,X)이 있을경우 false 리턴
         if(!board[i][j].click(mouseX,mouseY,count)){
           // 하지만 모든 화면이 클릭 되어 있을 경우
           if( count == maxCount){
              break; 
           }
           count--;
           println("error");
           break;
         }

    }
  }
  //모든 화면이 클릭되었을 경우 마지막 한번더 클릭하면 화면 및 count 초기화
  if(count == maxCount)
  {
    count = 0;
    //초기화 
    startUp();
  }
}
//승패 확인 함수 호출
void checked()
{
  //세로열 확인 함수 리턴: -1일 경우 실패
  if(colsCheck() != -1){
    fill(0);
    rect( colsCheck()* 100 + 45 , 0, 8,height);
    //게임 종료 준비
    count = maxCount-1;
  }
  //가로열 확인 함수 리턴: -1일 경우 실패
  if(rowsCheck() != -1){
    fill(0);
    rect( 0 , rowsCheck()* 100 + 45 , width,8);
    //게임 종료 준비
    count = maxCount-1;
  }
  //대각선 확인 함수 리턴: -1일 경우 실패
  if( diagonalCheck() != -1){
     if( diagonalCheck() == 1){
        line(0,0, width, height) ;
     }
     if( diagonalCheck() == 2){
        line(width,0,0,height ) ;
     }
     //게임 종료 준비
      count = maxCount-1;
  }
}
//세로열 확인 함수 리턴: -1 또는 완료된 cols count
int colsCheck(){
  int nowState = 0;
  // 리턴 값 초기화 -1
  int returnIndex = -1;
    for(int i = 0; i < cols; i++){
        nowState = board[i][0].getState();
        // 현재 상태 클릭 안된경우 (0) 
        if( nowState == 0){
           continue; 
        }
        for(int j =0; j < rows; j++){
          if( nowState == board[i][j].getState() ){
              returnIndex = i;
              // 끝까지 확인한 경우 해당 리턴  
              if( j+1 == rows ){
                 return returnIndex; 
              }
          }
          else{
              returnIndex = -1;
              break;
          }
        }
    }
    return returnIndex;
}
// 가로열 확인 함수 리턴: -1 또는 완료된 rows count
int rowsCheck(){
  int nowState = 0;
  // 리턴 값 초기화 -1  
  int returnIndex = -1;
    for(int i = 0; i < cols; i++){
        nowState = board[0][i].getState();
        // 현재 상태 클릭 안된경우 (0)         
        if( nowState == 0){
           continue; 
        }
        for(int j =0; j < rows; j++){
          if( nowState == board[j][i].getState() ){
              returnIndex = i;
              //끝까지 확인한 경우 리턴
              if( j+1 == rows ){
                 return returnIndex; 
              }
          }
          else{
              returnIndex = -1;
              break;
          }
        }
    }
    return returnIndex;
}
// 대각선을 확인하는 함수 리턴: -1또는 순행 1, 역행 2
int diagonalCheck(){
  int nowState = 0;
  int returnIndex = -1;
  //순행 검사
  nowState = board[0][0].getState();
  for(int i = 0; i < cols; i++){
      if( nowState == 0){
          break;
      }
      if( nowState == board[i][i].getState()){
         returnIndex = 1; 
         if( i + 1 == cols){
            return returnIndex; 
         }
      }
      else{
         returnIndex = -1; 
         break;
      }
  }
  //역행 검사
  // 02, 11, 02
  nowState = board[cols-1][0].getState();
  int tempIndex = 0;
  for(int i = cols-1 ; i > 0; i--){
      if( nowState == 0){
          break;
      }
      if( nowState == board[tempIndex][i].getState()){
         returnIndex = 2; 
         tempIndex++;
         if( i == cols){
            return returnIndex; 
         }
      }
      else{
         returnIndex = -1; 
         break;
      }
  }
  return returnIndex;
}
